/*
*   $Id: CCMerchantTest.h,v 1.6 1998/03/11 20:34:38 vchen Exp $
*
*   System     :   Merchant Connection Kit
*
*   Author     :   CYCH Development staff
*   Description:   Header for Module of customizable functions 
*                  shared by MCK CGI scripts
*   Notes      :   Each merchant should have a copy of this which is customized
*                  to integrate with the merchant storefront
*
*                         COPYRIGHT NOTICE
*
*   The contents of this file is protected under the United States
*   copyright laws as an unpublished work, and is confidential and
*   proprietary to CyberCash, Inc.  Its use or disclosure in whole or in
*   part without the expressed written permission of CyberCash, Inc. is
*   prohibited.
*
*   (c) Copyright 1993-98 by CyberCash, Inc.  All rights reserved.
*
*/                                                                       

#ifndef _CCMERCHANTTEST_H_
#define _CCMERCHANTTEST_H_

#ifdef __cplusplus
extern "C" {
#endif

#include "CCNVlist.h"

/* Warning!  pointer arithmetic here that may not work with */
/*           multi-byte character sets!                     */

#define MAXTMPLINE 1024

extern THREAD char msgBuf[MAXTMPLINE];

   /* MAXTMPLINE should be bigger than biggest line you expect in a template. */

/*============================================================================
 * Merchant constants
 *===========================================================================*/

extern THREAD const char *configFile;

/*##########################################################
 * Constants to customize
 *##########################################################*/

/* This is here for total melt-down of templating. */
/* Otherwise, templates will be expanded for messaging. */

void TemplateFailure(char* message);

typedef struct t_OrderRec {
    char* oid;
    char* timestamp;
	char* price;
	char* orderValidTill;
	char* payload;
    char* orderDescr;
	char* customerId;
} OrderRec, *OrderRecPtr;

/* EXPERSHOP Remove these functions
int SaveOrderInfo (
	char* orderId, char* price, char* orderValidTill, char* payload, 
	char* orderDescr,char* customerId);

int GetOrderInfo (char* orderId, OrderRecPtr result);
*/

/* this does the lookup of an OrderID saved above */
int CheckOrderId (char* orderId);

/**********
*  Notification logging
*  Write the POP string (as received) to the configures notification file
*  This is about as simple as it gets...
**************
*/

int LogNotification(char* POPstr);

/*
*##################################
*  ExtractNotification
*
*  Input:  An order ID
*  Return:   An error code   (0 = OK, > 0  errno: file problem,
*                           -1 if record not found)
*  Output parameters:
*          An error message (if applicable)
*          An CCNVlistPtr vector containing the fields of the POP record
*
*  If you change the Notification Log format or what is saved in that log,
*  You will have to make matching changes here...
*
*  Note: The POP string is stored in URL encoded format,
*   exactly as it arrived in the notification/fulfillment cgi...
*
*#######################################
*/
 
CCNVlistPtr ExtractNotification(char* orderId, int* errcode, char* message);

#ifdef __cplusplus
};
#endif
#endif
